<template>
  <div class="text-titulo q-pa-xs">{{ titulo }}</div>

  <q-card class="q-mt-sm">
    <q-table
      dense
      flat
      bordered
      :rows="dataSet"
      :columns="columnas"
      row-key="uuid"
      :rows-per-page-options="[0]"
      hide-pagination
      :loading="loading"
    >
      <!--------------------------------------
            loading
          ---------------------------------------->
      <template v-slot:loading>
        <Loading showing />
      </template>

      <template v-slot:no-data>
        <div
          class="full-width row flex-center text-orange q-gutter-sm"
          v-if="!loading"
        >
          <q-icon size="2em" name="sentiment_dissatisfied" />
          <span> No existen eventos activos </span>
        </div>
      </template>

      <template v-slot:body-cell-evento="props">
        <q-td :props="props">
          <q-item>
            <q-item-section top avatar>
              <q-avatar>
                <img
                  :src="
                    '/img/areas/' + props.row.area_codigo.toLowerCase() + '.svg'
                  "
                  width="50"
                  height="50"
                />
              </q-avatar>
            </q-item-section>

            <q-item-section>
              <q-item-label>{{ props.row.evento }}</q-item-label>
              <q-item-label caption lines="2">
                <span>Area :</span> {{ props.row.area }}
              </q-item-label>
              <q-item-label caption lines="3">
                <span>Org. :</span> {{ props.row.organismo }}
              </q-item-label>
              <q-item-label caption lines="2">
                <span>Cierre Inscripcion:</span>
                {{ $filters.Date(props.row.cierre_inscripcion) }} 23:59
              </q-item-label>
            </q-item-section>
          </q-item>
        </q-td>
      </template>

      <template v-slot:body-cell-costo="props">
        <q-td :props="props"> ${{ props.row.costo }} </q-td>
      </template>

      <template v-slot:body-cell-detalle="props">
        <q-td :props="props">
          <q-item class="max-w">
            <q-item-section>
              <q-item-label caption v-if="props.row.experiencia">
                <q-chip
                  class="full-width"
                  dense
                  square
                  :color="props.row.experiencia.instancias.color"
                  text-color="white"
                >
                  <span class="text-center full-width">
                    {{ props.row.experiencia.instancias.descripcion }}
                  </span>
                </q-chip>
              </q-item-label>

              <q-item-label caption lines="1">
                <span>Fecha Inicio:</span>
                {{ $filters.DateTime(props.row.fecha_evento) }}
              </q-item-label>

              <q-item-label caption lines="2">
                <span>Modalidad:</span>
                {{ props.row.modalidad }}
              </q-item-label>

              <q-item-label caption lines="3">
                <span>Cupo:</span>
                {{
                  props.row.cupo_cantidad === 0
                    ? 'Sin Cupo'
                    : props.row.cupo_cantidad
                }}
              </q-item-label>

              <q-item-label
                caption
                lines="4"
                v-if="
                  props.row.inscripto_uuid != '' &&
                  props.row.rama &&
                  props.row.inscripto_rama !== '' &&
                  props.row.inscripto_rama !== undefined
                "
              >
                <span>Rama Inscripto :</span>
                <q-chip
                  dark
                  size="sm"
                  square
                  :color="$getRama(props.row.inscripto_rama).color"
                  :label="$getRama(props.row.inscripto_rama).texto"
                />
              </q-item-label>
            </q-item-section>
          </q-item>
        </q-td>
      </template>

      <template v-slot:body-cell-miestado="props">
        <q-td :props="props">
          <template v-if="props.row.inscripto_uuid">
            <q-chip square dark color="green" icon="thumb_up">
              Si Participo
            </q-chip>
          </template>
          <template v-else>
            <q-chip square dark color="red" icon="thumb_down">
              No Participo
            </q-chip>
          </template>
        </q-td>
      </template>

      <template v-slot:body-cell-opciones="props">
        <q-td :props="props">
          <q-btn
            @click="showPauta(props.row.pauta)"
            flat
            color="blue-grey"
            icon="picture_as_pdf"
          >
            Pauta
          </q-btn>

          <template
            v-if="
              props.row.beneficiarios &&
              user.details.is.grupo &&
              user.details.persona.adulto
            "
          >
            <q-btn
              flat
              color="green"
              icon="group_add"
              :to="'/main/inscripciones/' + props.row.uuid"
            >
              Avanzado
            </q-btn>
          </template>
          <template v-else>
            <!-- Esta vista la muestro a beneficiarios y adultos que no trabajan en grupo -->
            <template v-if="validoEstadoEvento(props.row)">
              <template v-if="props.row.inscripto_uuid">
                <q-btn
                  flat
                  color="red"
                  icon="clear"
                  @click="cancelarParicipacion(props.row.inscripto_uuid)"
                >
                  Darme de Baja
                </q-btn>
              </template>
              <template v-else>
                <template v-if="!props.row.cupo">
                  <q-chip square text-color="white"> Sin Cupo </q-chip>
                </template>
                <template v-else>
                  <q-btn
                    flat
                    color="green"
                    icon="add"
                    @click="abrirModalInscripcion(props.row)"
                  >
                    Anotarme
                  </q-btn>
                </template>
              </template>
            </template>
            <template v-else>
              <q-chip square text-color="white"> Inscripcion Cerrada </q-chip>
            </template>
          </template>
        </q-td>
      </template>
    </q-table>

    <q-dialog
      v-model="formModal.modal"
      @before-hide="cerrarModalInscripcion()"
      persistent
      transition-show="scale"
      transition-hide="scale"
    >
      <q-card style="width: 600px">
        <q-bar color="red">
          Confirmación de Inscripción
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>

        <q-card-section>
          <div class="q-gutter-md">
            <q-select
              v-model="formModal.pauta"
              style="min-width: 150px"
              dense
              filled
              emit-value
              stack-label
              map-options
              :options="[
                { label: 'NO he leído la pauta', value: 'N' },
                { label: 'SI he leído la pauta', value: 'S' },
              ]"
              label="Confirma la lectua de la pauta: "
            />

            <q-banner
              v-if="formModal.pedirRama"
              dense
              rounded
              class="text-white bg-blue-grey"
            >
              El evento requiere confirmar en qué rama se realizará la cursada.
            </q-banner>

            <SelectRama
              v-if="formModal.pedirRama"
              v-model="formModal.rama"
              :multiple="false"
              label="Seleccion de Rama"
            />
            <q-banner inline-actions class="text-white bg-blue text-center">
              Usted y su Jefe de Grupo recibirán un correo electrónico con la
              confirmación de participación al evento.
            </q-banner>
          </div>
        </q-card-section>

        <q-card-actions align="right" class="bg-white text-teal">
          <q-btn
            v-if="formModal.pauta === 'S'"
            class="full-width"
            color="green"
            @click.prevent="confirmarParicipacion"
            label="Confirmar Mi Participacion"
            v-close-popup
          />
          <q-btn
            v-if="formModal.pauta === 'N'"
            class="full-width"
            color="red"
            label="CANCELAR"
            v-close-popup
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-card>
</template>

<script lang="ts">
import { PropType, defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
// inside of a Vue file
import { useQuasar } from 'quasar';
import { useUserStore } from 'src/stores/user';
import moment from 'moment';
import { EventoInscripcionesInterface } from 'src/interfaces/EventosInterface';
import SelectRama from 'src/components/Form/selectRama.vue';
import Loading from 'src/components/Loading.vue';
// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'evento', label: 'Evento', field: 'evento', align: 'left' },
  { name: 'costo', label: 'Costo', field: 'costo', align: 'left' },
  { name: 'detalle', label: 'Detalle', field: 'detalle', align: 'left' },
  { name: 'miestado', label: 'Mi Estado', field: 'miestado', align: 'left' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  name: 'EventosPage',
  components: { Loading, SelectRama },

  props: {
    tipo: {
      type: String as PropType<string>,
      required: true,
    },
    titulo: {
      type: String as PropType<string>,
      required: true,
    },
  },

  setup(props) {
    const $q = useQuasar();
    const loading = ref(true);
    const dataSet = ref<EventoInscripcionesInterface[]>([]);
    const user = useUserStore();
    const modalInscripcion = ref(true);

    onMounted(() => {
      getEventos();
    });
    function getEventos() {
      api
        .get('/api/eventos/eventos/disponibles?tipo=' + props.tipo)
        .then((response: AxiosResponse) => {
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .finally(() => {
          loading.value = false;
        });
    }
    function validoEstadoEvento(evento: EventoInscripcionesInterface) {
      const fechaCierre = moment(evento.cierre_inscripcion).format(
        'YYYY-MM-DD'
      );
      return moment().diff(fechaCierre, 'days') < 1;
    }

    function showPauta(texto: string) {
      $q.dialog({
        title: 'Pauta del Evento',
        message: texto,
        html: true,
        fullWidth: true,
        ok: {
          label: 'Cerrar',
        },
        persistent: true,
      });
    }

    const formModal = ref({
      modal: false,
      pauta: 'N',
      rama: null,
      pedirRama: false,
      evento_uuid: '',
    });

    function cerrarModalInscripcion() {
      formModal.value.modal = false;
      formModal.value.pauta = 'N';
      formModal.value.rama = null;
      formModal.value.pedirRama = false;
      formModal.value.evento_uuid = '';
    }

    function abrirModalInscripcion(evento: EventoInscripcionesInterface) {
      formModal.value.modal = true;
      formModal.value.evento_uuid = evento.uuid;
      formModal.value.pedirRama = evento.rama;
    }

    function confirmarParicipacion() {
      loading.value = true;
      formModal.value.modal = false;
      api
        .post('/api/eventos/inscriptos', {
          lectura: 'S',
          evento_uuid: formModal.value.evento_uuid,
          rama: formModal.value.rama,
        })
        .then(() => {
          getEventos();
        })
        .catch(() => {
          loading.value = false;
        });
    }
    function cancelarParicipacion(inscriptoUuid: string) {
      loading.value = true;

      $q.dialog({
        title: 'Generacion de baja',
        message: 'Esta seguro de generar la baja ?',
        persistent: true,

        cancel: {
          color: 'green',
          label: 'Cancelar',
        },
        ok: {
          color: 'red',
          label: 'Dar de baja',
        },
      })
        .onOk(() => {
          $q.notify({
            message: 'Generando la baja',
            color: 'green',
            position: 'top',
          });

          api
            .delete('/api/eventos/inscriptos', {
              params: { inscripto_uuid: inscriptoUuid },
            })
            .then(() => {
              getEventos();
            });
        })
        .onCancel(() => {
          loading.value = false;
          //

          $q.notify({
            message: 'Se Cancelo la baja',
            color: 'orange',
            position: 'top',
          });
        });
    }

    return {
      loading,
      dataSet,
      columnas,
      showPauta,
      validoEstadoEvento,
      user,
      formModal,
      modalInscripcion,
      abrirModalInscripcion,
      cerrarModalInscripcion,
      confirmarParicipacion,
      cancelarParicipacion,
    };
  },
});
</script>
